<!DOCTYPE html>
<html lang="pt-br">
  <head>
    <title>Nginx & vsftpd</title>
    <meta charset="utf-8">
    <link rel="stylesheet" href="https://bootswatch.com/4/slate/bootstrap.min.css" crossorigin="anonymous">
  </head>
  <body>
    <div class="container mt-4">
      <div class="text-center">
        <h1>Nginx & vsftpd</h1>
      </div>
        <h2>Instalação</h2>
        <p>
            A configuração do vsftpd é feita juntamente com o NGINX, a partir do manifesto principal, encontrado em <code>manifests/default.pp</code>. Nele, é definido a variável PATH do sistema, executado o comando <code>apt-get update</code> do sistema, instalado os pacotes <code>nginx</code> e <code>vsftpd</code>. Então é copiado este arquivo de instruções para a pasta pública do NGINX, e o arquivo de configurações do vsftpd para <code>/etc/vsftpd.conf</code>, então este último é reiniciado. Por fim, executado o serviço <code>nginx</code>.
        </p>
        <p>
            Veja o código fonte do manifesto principal <code>manifests/default.pp</code>:
        </p>
        <pre><code>
            # Define o PATH do sistema
            Exec { path => [ "/usr/bin:/usr/sbin:/bin:/usr/local/bin:/usr/local/sbin:/sbin" ] }

            # Instala o pacote nginx e vsftpd após garantir que a lista de pacotes está atualizada
            package { [ 'nginx', 'vsftpd' ]:
              require => Class["system-update"],
              ensure  => 'installed',
            }

            # Copia os arquivos de README para raiz /var/www/
            exec {"copia_readme":
                 command => "sudo cp /vagrant/README.html /usr/share/nginx/www/index.html",
                onlyif => ['ls -l /vagrant/README.html'],
                require => Package["nginx"]
            }

            # Copia os arquivos de configuração do servidor FTP & Reinicia-o
            exec {"copia_config":
                command => "sudo cp -rf /vagrant/vsftpd.conf /etc/vsftpd.conf; sudo restart vsftpd",
                onlyif => ['ls -l /etc/vsftpd.conf'],
                require => Package["vsftpd"]
            }

            # Certifica-se que os serviços nginx está em execução
            service { "nginx":
              ensure  => "running",
              require => Package["nginx"],
            }

            # Instala o módulo system-update
            include system-update
        </code></pre>
        <br>
        A configuração personalizada do vsftpd comenta o comando <code>anonymous_enable=NO</code> e habilita <code>write_enable=YES</code>.

        O usuário e senha para acesso ao FTP em <code>ftp://192.168.33.16</code> é <code>vagrant</code>.
        <br>
        <h2>Apache vs. NGINX</h2>
        <br>
        <h3>Mercado</h3>
        <p>
        O Apache é foi muito utilizado entre o final da década de 1990 até 2011, quando servia cerca de 60% das principais páginas web mundiais. Em 2018, essa porcentagem caiu abaixo de 35 e vem caindo a uma velocidade significativa. Já o Microsoft IIS tem se mantido estável, aumentando ligeiramente sua posição no mercado, alcançando cerca de 30% neste ano. O terceiro lugar é mantido pelo NGINX, que em comparação serve 16% dos web sites e têm crescido cerca de 1% ao ano.
        </p>
        <div class="col-12 text-center">
            <figure class="figure">
                <img src="img.jpg" class="figure-img img-fluid rounded" alt="A generic square placeholder image with rounded corners in a figure.">
                <figcaption class="figure-caption">Comparação de mercado de servidores: Todos os sites (esquerda) e entre os sites mais movimentados.</figcaption>
            </figure>
        </div>
        <br>
        <h3>Performance</h3>
        <h4>Conteúdo Estático</h4>
        <p>
            Segundo benchmarks realizados (<a target="_blank" href="https://www.eschrade.com/page/performance-of-apache-2-4-with-the-event-mpm-compared-to-nginx/   ">fonte</a>), o NGINX é cerca de 2,5 vezes mais rápido do que o Apache em um cenário com 1.000 conexões concorrentes. Outro teste, com 512 conexões concorrentes, mostrou que o NGINX é aproximadamente 2 vezes mais rápido e consumiu cerca de 4% a menos de memória (<a target="_blank" href="http://www.speedemy.com/apache-vs-nginx-2015/">fonte</a>). Outras fontes mostram resultados similares, reforçando a ideia de que o NGIX serve conteúdo estático de forma mais rápida e eficiente do que o Apache.
        </p>    
        <h4>Conteúdo Dinâmico</h4>
        <p>
            Ambas as ferramentas apresentaram desempenho similar quando se trata de servir conteúdo dinâmico, suportando 108 requisições por segundo com 16 requisições em paralelo (<a target="_blank" href="http://www.speedemy.com/apache-vs-nginx-2015/">fonte</a>).
        </p>
<br>
        <h3>Suporte a SOs</h3>
        <p>
            O Apache pode ser executado em praticamente qualquer sistema Unix-like, e tem suporte completo para o Windows. Já o NGINX também suporta vários sistemas Unix-like e tem suporte ao Windows, contudo seu desempenho neste último não é tão alto quanto nas outras plataformas.
        </p>
        <br>
        <h3>Flexibilidade</h3>
        <p>
            A customização dos servidores web pode ser feita a partir da escrita de módulos. O Apache suporta o carregamento dinâmico de módulos há mais tempo, sendo amplamente utilizado. Já o NGINX recebeu esse tipo de função apenas no início de 2016; anteriormente era requerido que o administrador compilasse os módulos no binário da ferramenta
        </p>
        <br>
        <h3>Documentação</h3>
        <p>
            Ambas as ferramentas possuem documentação bem feita e ampla. O NGINX também oferece sessões de treinamento online e no local, incluindo até certificações.
        </p>
        <br>
        <h3>Suporte</h3>
        <p>
            Tanto o NGINX quanto o Apache mantém suporte por meio de listas de e-mail, IRC e Stack Overflow. O Apache oferece também suporte comercial por meio de empresas terceirizadas; e o NGINX tem seu produto chamado NGINX Plus, que adiciona também algumas funcionalidades como balanceamento de carga, streaming de mídia e monitoramento.
        </p>
        <br>
        <h3>Referências</h3>
        <p>
                Este artigo é um resumo-tradução de uma comparação publicada pelo website Hosting Advice e está disponível em <a href="https://www.hostingadvice.com/how-to/nginx-vs-apache/">https://www.hostingadvice.com/how-to/nginx-vs-apache/</a>.
        </p>
    </div>
  </body>
</html>